// -*- coding: utf-8 -*-
// Skrypt używany przez piecedetails.xul

/////////////////////////////////////////////////////////////////
// Funkcje wykorzystywane z XUL-a
/////////////////////////////////////////////////////////////////

// Wołane przy inicjalizowaniu okna. Generuje cały dynamiczny
// content.

function initializePiecesPane() {

    // Iterujemy warianty, dla każdego:
    // - dodajemy linijkę prezentującą go
    var piecesTable = document.getElementById("pieces_table");
    // var setsPreferences = document.getElementById("sets_preferences");

    var size = getCurrentSize();

    for(var i=0, variant; variant=smtvariants.variantList[i]; i++) {
        // setsPreferences.appendChild(
        //    smtext.xulCreatePreference("set_" + variant.internalName, "string"));
        piecesTable.appendChild(
            createPiecesRow(variant.internalName,
                            variant.publicName.replace(/ Chess$/, ''),
                            size));
    }
}

function changePieceSet(variantName) {
    populatePieceSelector(variantName);
    flipToSelectView();
}

/////////////////////////////////////////////////////////////////
// Formatka chessdetails.xul
/////////////////////////////////////////////////////////////////

// Okno chessdetails
function initializeChessPieceSelector() {
    populatePieceSelector('chess', 1);
}

/////////////////////////////////////////////////////////////////
// Wydzielone procedury - 'cząstki'
/////////////////////////////////////////////////////////////////

// Kreuje i tworzy cały wiersz informacji o podanym wariancie
function createPiecesRow(variantName, variantPublicName, size) {

    // Pobieramy info co jest ustawione teraz
    var setObj = getCurrentSetFor( variantName );

    // Dodajemy całą linijkę zarządzania wariantem
    var newRow = document.createElement("row");
    newRow.setAttribute("id", "row_" + variantName);
    newRow.setAttribute("align", "center");

    // Nazwa wariantu
    newRow.appendChild( smtext.xulCreateLabel( variantPublicName ) );

    // Przycisk Change
    var changeButton = smtext.xulCreateButton(
        "Change", "changePieceSet('" + variantName + "')");
    newRow.appendChild(changeButton);

    // Grafiki
    var gfxBox = createHorizontalSetSample(setObj, size);
    gfxBox.setAttribute("id", variantName);
    newRow.appendChild(gfxBox);

    // Nazwa aktualnego set-a
    var setLabel = smtext.xulCreateLabel( setObj.label() );
    setLabel.setAttribute("id", variantName + "_set_name");
    newRow.appendChild(setLabel);

//     // Ukryte pole powiązane z preferencjami
//     var tBox = document.createElement("textbox");
//     tBox.setAttribute("id", variantName + "_set_name");
//     tBox.setAttribute("preference", "pref_set_" + variantName);
//     tBox.setAttribute("preference-editable", "true");
//     tBox.setAttribute("onsyncfrompreference",
//                       "return onPieceSetFromPref('" + variantName + "')");
//     tBox.setAttribute("onsynctopreference",
//                       "return onPieceSetToPref('" + variantName + "')");
//     //tBox.setAttribute("size", 8);
//     tBox.setAttribute("hidden", "true");
//     newRow.appendChild(tBox);

    return newRow;
}

// function onPieceSetFromPref(variantName) {
//     //var x = updateSetInfo(variantName).name;
//     smtext.dump("setfrompref: " + variantName + ": " + x);
//     return x;
// }

// function onPieceSetToPref(variantName) {
//     var x = document.getElementById(variantName + "_set_name").value;
//     smtext.dump("settopref: " + variantName + ": " + x);
//     return x;
// }

function onSizeChanged() {
    // Nie ma co kombinować z robieniem updateSetInfo dla wszystkich po kolei.
    // Kreujemy okno od początku

    // smtext.dump("size changed, reloading pieces");

    var oldPiecesTable = document.getElementById("pieces_table");
    var newPiecesTable = document.createElement('rows');
    var size = getCurrentSize();

    for(var i=0, variant; variant=smtvariants.variantList[i]; i++) {
        newPiecesTable.appendChild(
            createPiecesRow(variant.internalName, variant.publicName, size));
    }

    //smtext.dump("replacing old table");

    oldPiecesTable.parentNode.replaceChild(newPiecesTable, oldPiecesTable);
    newPiecesTable.setAttribute("id", "pieces_table");
}

// Updates displayed name and sample images according to the current size
// and set. Returns setObj as it may be of some use
function updateSetInfo(variantName, specName, specSize) {
    var setObj = getCurrentSetFor(variantName, specName);
    var size = getCurrentSize(specSize);

    // ToDo: jeśli ani set ani rozmiar się nie zmienił, nic nie robić
    // if (smt_set == setObj.name && oldBox.smt_size == size) {
    //    return setObj;
    // }

    var oldRow = document.getElementById("row_" + variantName);
    var newRow = createPiecesRow(
        variantName, smtvariants.variantPublicByInternal(variantName), size);

    oldRow.parentNode.replaceChild(newRow, oldRow);

    return setObj;
}

function populatePieceSelector(variantName, doCloseWindow) {
    var size = getCurrentSize();
    var setObj = getCurrentSetFor(variantName);

    var variantPublicName = smtvariants.variantPublicByInternal(variantName);

    // Zapisanie informacji co właściwie zmieniamy
    var caption = document.getElementById("setSelectorCaption");
    caption.setAttribute("label", variantPublicName);
    caption.selectorVariant = variantName;
    document.getElementById("headerlabel").setAttribute("value", "Customize piece-set for " + variantPublicName);

    // Wrzucenie wszystkich możliwości
    var oldList = document.getElementById("setSelectorRows");
    if (oldList.firstChild && oldList.listForSize == size && smtpieces.same_applicable(
            oldList.listForVariant, variantName)) {
        oldList.listForVariant = variantName;
        return;
    }

    var newList = document.createElement("rows");
    populatePieceRows(newList, size, variantName, setObj.name(), doCloseWindow);
    newList.listForSize = size;
    newList.listForVariant = variantName;
    newList.setAttribute("id", "setSelectorRows");
    oldList.parentNode.replaceChild(newList, oldList);
}

// Dodaje do podanego obiektu DOM listę
// obrazków
function populatePieceRows(rows, size, variant, selectedName, doCloseWindow) {
    var currentPiecesRow;
    var currentButtonsRow;
    var plist = smtpieces.allSuitable(variant, size);
    var itemNo = 0;
    var closePar = "";
    if (doCloseWindow) {
        closePar = ", 1";
    }
    for(var pieceIdx = 0, pieceCount = plist.length;
        pieceIdx < pieceCount;
        ++ pieceIdx) {

        var setObj = plist[pieceIdx];
        if (itemNo % 3 == 0) {
            if (currentPiecesRow) {
                rows.appendChild(currentPiecesRow);
                rows.appendChild(currentButtonsRow);
            }
            currentPiecesRow = document.createElement("row");
            currentButtonsRow = document.createElement("row");
        }
        ++ itemNo;
        
        currentPiecesRow.appendChild(createBoxSetSample(setObj, size));
        currentButtonsRow.appendChild(
                smtext.xulCreateButton(setObj.label(),
                                       "return saveSelectedSet('"+setObj.name()+"'" + closePar + ");"));
        if (itemNo % 3 != 0) {
            currentPiecesRow.appendChild(smtext.xulCreateSpacer("100"));
            currentButtonsRow.appendChild(smtext.xulCreateSpacer("100"));
        }
    }
    if (currentPiecesRow) {
        if (itemNo % 3 < 2) {
            currentPiecesRow.appendChild(smtext.xulCreateSpacer("100"));
        }
        rows.appendChild(currentPiecesRow);
        rows.appendChild(currentButtonsRow);
    }
}

function saveSelectedSet(setName, doCloseWindow) {
    var variantName = document.getElementById("setSelectorCaption").selectorVariant;

    var setsPane = document.getElementById("panePieceSets");

    //var dsn = document.getElementById(variantName + "_set_name");
    //dsn.value=setName;
    //setsPane.userChangedValue(dsn);

    smtext.prefman.setValue("set_" + variantName, setName);

    if (! doCloseWindow) {
        // piecedetails.xul
        updateSetInfo(variantName, setName);
        flipToMainView();
    } else {
        // chessdetails.xul
        window.close()
    }
    //smtext.xulScrollIntoView(
    //    setsPane,
    //    document.getElementById(variantName + "_set_name"));
}


function cancelSelectedSet() {
    var variantName = document.getElementById("setSelectorCaption").selectorVariant;
    flipToMainView();
    //smtext.xulScrollIntoView(
    //    document.getElementById("panePieceSets"),
    //    document.getElementById(variantName + "_set_name"));
}

function flipToSelectView() {
    document.getElementById("mainSettingsGroupBox")
        .setAttribute("hidden", "true");
    document.getElementById("piecesAssignmentGroupBox")
        .setAttribute("hidden", "true");
    document.getElementById("pieceSetSelectGroupBox")
        .setAttribute("hidden", "false");
}

function flipToMainView() {
    document.getElementById("mainSettingsGroupBox")
        .setAttribute("hidden", "false");
    document.getElementById("piecesAssignmentGroupBox")
        .setAttribute("hidden", "false");
    document.getElementById("pieceSetSelectGroupBox")
        .setAttribute("hidden", "true");
    document.getElementById("headerlabel").setAttribute("value", "Per-variant piece sets");
}


/////////////////////////////////////////////////////////////////
// Funkcje pomocnicze
/////////////////////////////////////////////////////////////////

// Wyciąga z preferencji informację jaki jest aktualny set dla
// podanego wariantu (może być też 'chess'), zwraca setObj.
//
// Parametry:
// - nazwa wariantu (obowiązkowy)
// - zadana explicite nazwa (używane przy wyborach) (albo nic)
function getCurrentSetFor(variantName, specName) {
    //smtext.dump("Searching set for " + variantName);
    var setName;
    if (specName) {
        //smtext.dump("Using specified: " + specName);
        setName = specName;
    }
//     if (! setName && searchInWindow) {
//         var pref = document.getElementById("pref_set_" + variantName);
//         if (pref) {
//             setName = pref.value;
//             if (setName) {
//                 //smtext.dump("using window item: " + setName);
//             }
//         }
//     }
    if (! setName) {
        setName = smtext.prefman.getValue("set_" + variantName);
        //smtext.dump("using preference set_" + variantName + ": " + setName);
    }
    var setObj;
    if (setName) {
        setObj = smtpieces.pieceByName(setName);
    } else {
        setObj = smtpieces.firstMatchingPiece(variantName);
        // setName = setObj.name();
    }
    return setObj;
}

// Wyciąga z preferencji informację jaki jest aktualny rozmiar.
// Może być też podany parametr, wtedy on jest uwzględniany
// jako pierwszy (używane przy modyfikacjach)
function getCurrentSize(specSize) {
    var size = specSize;
    if (! size) {
        var pref = document.getElementById("pref_piece_size");
        if (pref) {
            size = pref.value;
        }
    }
    if (! size) {
        size = smtext.prefman.getValue("piece_size") || '32';
    }
    return size;
}

// Tworzy i zwraca cały hbox z przykładem obrazków
function createHorizontalSetSample(setObj, size) {
    //smtext.dump("createHorizonstalSample: " + setObj.name + " " + size);
    var box = document.createElement("hbox");
    box.setAttribute("pack", "center");
    addHorizontalSetSample(box, setObj, size);
    return box;
}

// Dodaje do podanego obiektu DOM przyklad podanego
// piece-seta (tj. sekwens przykładowych obrazków)
function addHorizontalSetSample(parent, setObj, size) {
    var pieces = [ 'wkb', 'wbw', 'wnb', 'hwrw', 'b', 
                   'bkw', 'hbbb', 'bnw', 'brb' ];
    // smtext.dump("sample: " + setObj.name + " " + size);
    for (var i = 0, piece; piece = pieces[i]; i++) {
        parent.appendChild(
            smtext.xulCreateImage(setObj.pieceUrl(piece, size)));
    }
}

// Tworzy box z przykładem grafik
function createBoxSetSample(setObj, size) {

    var vbox = document.createElement("vbox");
    var hbox1 = document.createElement("hbox");
    var hbox2 = document.createElement("hbox");
    var hbox3 = document.createElement("hbox");

    hbox1.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('brw', size)));
    hbox1.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('bnb', size)));
    hbox1.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('bbw', size)));
    hbox1.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('bqb', size)));
    hbox1.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('bkw', size)));

    hbox2.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('wpb', size)));
    hbox2.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('w', size)));
    hbox2.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('b', size)));
    hbox2.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('hw', size)));
    hbox2.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('bpb', size)));

    hbox3.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('wkw', size)));
    hbox3.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('wqb', size)));
    hbox3.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('wbw', size)));
    hbox3.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('hwnb', size)));
    hbox3.appendChild(
        smtext.xulCreateImage(setObj.pieceUrl('wrw', size)));

    vbox.appendChild(hbox1);
    vbox.appendChild(hbox2);
    vbox.appendChild(hbox3);

    return vbox;
}

