// -*- coding: utf-8 -*-
// SM Tuning.
//
// Funkcje pomocnicze wykorzystywane na poziomie rozszerzenia

var smtext = {

    prefman : new smtuning_PrefManager(),

    ////////////////////////////////////////////////////////////////////////////////
    // Tworzenie różnych elementów XUL-owych
    ////////////////////////////////////////////////////////////////////////////////

    // Stworzenie labelki o podanym tekście
    xulCreateLabel : function(labelText) {
        var newLabel = document.createElement("label");
        newLabel.setAttribute("value", labelText);
        return newLabel;
    },

    // Stworzenie elementu preference o identyfikatorze pref_NAME
    // odpowiadającego preferencji extensions.smtuning.NAME i podanym typie.
    // Wynik należy appendChild-ować do bloku <preferences>
    xulCreatePreference : function(prefName, prefType) {
        var newPref = document.createElement("preference");
        newPref.setAttribute("id", "pref_" + prefName);
        newPref.setAttribute("name", "extensions.smtuning." + prefName);
        newPref.setAttribute("type", prefType);
        return newPref;
    },

    // Stworzenie elementu obrazka
    xulCreateImage : function(src) {
        var newImage = document.createElement("image");
        newImage.setAttribute("src", src);
        return newImage;
    },

    // Stworzenie elementu menuitem (do wklejenia w ramach <menu>)
    xulCreateMenuItem : function(label, value) {
        var x = document.createElement("menuitem");
        x.setAttribute("label", label);
        x.setAttribute("value", value);
        return x;
    },

    xulCreateButton : function(label, oncommand) {
        var x = document.createElement("button");
        x.setAttribute("label", label);
        x.setAttribute("oncommand", oncommand);
        return x;
    },

    xulCreateSpacer : function(flex) {
        var x = document.createElement("spacer");
        x.setAttribute("flex", flex);
        return x;
    },

    // Zapewnienie że dany element widać. scrollObj to coś co wyświetla
    // scrollbary (zwykle element z ustawionym overflow), visibleObj
    // to coś, co ma być widoczne
    xulScrollIntoView : function(scrollObj, visibleObj) {
        var xpcomInterface = scrollObj.boxObject.QueryInterface(
           Components.interfaces.nsIScrollBoxObject);
        if (xpcomInterface) {
            xpcomInterface.ensureElementIsVisible(visibleObj);
        }
    },

    ////////////////////////////////////////////////////////////////////////////////
    // Funkcje pomocnicze różne
    ////////////////////////////////////////////////////////////////////////////////

    openPrefs : function() {
        window.open("chrome://smtuning/content/options.xul","","dialog,centerscreen,alwaysRaised,chrome,toolbar");
    },

    ////////////////////////////////////////////////////////////////////////////////
    // Debugging
    ////////////////////////////////////////////////////////////////////////////////

    dump : function(aMessage) {
        var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
            .getService(Components.interfaces.nsIConsoleService);
        consoleService.logStringMessage("smtuning: " + aMessage);
    }
};