// -*- coding: utf-8 -*-
// SM Tuning.
//
// Funkcje i stałe związane z obsługą wariantów

///////////////////////////////////////////////////////////////////////
// Reprezentacja wariantu
///////////////////////////////////////////////////////////////////////

function SmtVariant(publicName, internalName, isDark) {
    this.publicName = publicName;
    this.internalName = internalName;
    this.isDark = isDark;
}

///////////////////////////////////////////////////////////////////////
// Publiczny interfejs
///////////////////////////////////////////////////////////////////////

var smtvariants = {

    variantList : [
                   new SmtVariant("Chess", "chess"),
                   new SmtVariant("Chess960", "chess960"),
                   new SmtVariant("All Queens", "allqueens"),
                   new SmtVariant("Double Fischer Random", "doublefischerrandom"),
                   new SmtVariant("Symmetrical Fischer Random Chess", "symmetricalfischerrandom"),
                   new SmtVariant("Chess480", "chess480"),
                   new SmtVariant("Fianchetto Chess", "fianchetto"),
                   new SmtVariant("Upside Down Chess", "upsidedown"),
                   new SmtVariant("CrazyHouse", "crazyhouse"),
                   new SmtVariant("CrazyHouse960", "crazyhouse960"),
                   new SmtVariant("Dark CrazyHouse", "darkcrazyhouse", true),
                   new SmtVariant("Dark CrazyHouse 2", "darkcrazyhouse2", true),
                   new SmtVariant("LaoTzu Chess", "laotzu", true),
                   new SmtVariant("SunTzu Chess", "suntzu", true),
                   new SmtVariant("Tiszta Bolondokháza", "tisztabolondokhaza"),
                   new SmtVariant("Full House", "fullhouse"),
                   new SmtVariant("Shatranj", "shatranj"),
                   new SmtVariant("Crazy Elephant", "crazyelephant"),
                   new SmtVariant("Makruk (Thai Chess)", "makruk"),
                   new SmtVariant("Extinction Chess", "extinction"),
                   new SmtVariant("Three Checks", "threechecks"),
                   new SmtVariant("Capture Chess", "capturechess"),
                   new SmtVariant("Racing Kings", "racingkings"),
                   new SmtVariant("Atomic Chess", "atomic"),
                   new SmtVariant("Atomic960", "atomic960"),
                   new SmtVariant("Benedict Chess", "benedict"),
                   new SmtVariant("Benedict960", "benedict960"),
                   new SmtVariant("Chicken Chess", "chicken"),
                   new SmtVariant("Chicken960", "chicken960"),
                   new SmtVariant("Alice Chess 1", "alice1"),
                   new SmtVariant("Alice Chess 2", "alice2"),
                   new SmtVariant("Stanley Random Chess", "stanleyrandom"),
                   new SmtVariant("Suicide Chess", "suicide"),
                   new SmtVariant("Suicide960", "suicide960"),
                   new SmtVariant("Dark Suicide", "darksuicide", true),
                   new SmtVariant("Loser's Chess", "losers"),
                   new SmtVariant("Loser's 960", "losers960"),

                   new SmtVariant("Kriegspiel", "kriegspiel", true),
                   new SmtVariant("Dark1 (checkmate wins)", "darkchess1", true),
                   new SmtVariant("Dark2 (king capture wins)", "darkchess2", true),
                   new SmtVariant("Blindfold Chess", "blindfold")
                   //new SmtVariant("unratedchess", "unratedchess"),
                   //new SmtVariant("unratedchess960", "unratedchess960"),
                   //new SmtVariant("chessadvanced", "chessadvanced"),
                   //new SmtVariant("chessadvanced960", "chessadvanced960"),
                   ],

    // Zwraca wewnętrzną nazwę wariantu na bazie publicznej
    variantInternalByPublic : function(publicName) {
        //alert("pbn: " + name);
        for(var i=0, variant; variant=smtvariants.variantList[i]; i++) {
            //alert("pbn: ? " + set.label());
            if (variant.publicName == publicName) {
                return variant.internalName;
            }
        }
        // Awaryjnie
        return "chess";
    },

    // Zwraca publiczną nazwę wariantu na bazie wewnętrznej
    variantPublicByInternal : function(publicName) {
        //alert("pbn: " + name);
        for(var i=0, variant; variant=smtvariants.variantList[i]; i++) {
            //alert("pbn: ? " + set.label);
            if (variant.internalName == publicName) {
                return variant.publicName;
            }
        }
        // Awaryjnie
        return "SomethingIsWrong";
    },

    isDark : function(internalName) {
        for(var i=0, variant; variant=smtvariants.variantList[i]; i++) {
            if (variant.internalName == internalName) {
                return variant.isDark;
            }
        }
        // Awaryjnie
        return false;
    },

    showCheck : function(internalName) {
        if( internalName == "threechecks" ) {
            return true;
        } else {
            return false;
        }
    }

};
